/*
 * This file is part of the Owl Positioning System (OwlPS) project.
 * It is subject to the copyright notice and license terms in the
 * COPYRIGHT.t2t file found in the top-level directory of this
 * distribution and at
 *   https://code.lm7.fr/mcy/owlps/src/master/COPYRIGHT.t2t
 * No part of the OwlPS Project, including this file, may be copied,
 * modified, propagated, or distributed except according to the terms
 * contained in the COPYRIGHT.t2t file; the COPYRIGHT.t2t file must be
 * distributed along with this file, either separately or by replacing
 * this notice by the COPYRIGHT.t2t file's contents.
 */


#ifndef _OWLPS_POSITIONING_POSITIONINGALGORITHM_HH_
#define _OWLPS_POSITIONING_POSITIONINGALGORITHM_HH_

#include "request.hh"
#include "result.hh"

/// Super-class of all positioning algorithms
class PositioningAlgorithm
{
protected:
  /// Name of the algorithm
  const std::string name ;

public:
  explicit PositioningAlgorithm(const std::string &_name = "UnknownAlgorithm"):
    name(_name) {}
  virtual ~PositioningAlgorithm(void) {}

  const std::string& get_name(void) const ;

  virtual Result compute(const Request &request) = 0 ;
} ;



inline const std::string& PositioningAlgorithm::get_name() const
{
  return name ;
}



#endif // _OWLPS_POSITIONING_POSITIONINGALGORITHM_HH_
